;; newLispHanoi.lsp - graphics demo for newLISP-pdScript
;;
;; to run: (Hanoi:run 6 1)
;;
;;
;; Modified from Hanoi.lsp from newLSIP distribution
;; Ported to pdScript
;; Hans-Peter Wickern
;; 27.08.2011

(context 'Hanoi)

(define (delete-disk n  item itemlst polex polex1)
  (if (set 'item(find (assoc n disklst)disklst))
	(begin
	(set	'itemlst	(pop disklst item)
		'polex		(-(+(nth 1 itemlst)(/(-(nth 3 itemlst)(nth 1 itemlst))2))5)
		'polex1		(+(+(nth 1 itemlst)(/(-(nth 3 itemlst)(nth 1 itemlst))2))5)
	)
	(if (=(nth 2 itemlst)70)
	 (begin
	 (MAIN:pdImageRectangle MAIN:pdScriptInstanceAddr "pdImageRectangle" (string(nth 1 itemlst)) (string(nth 2 itemlst)) (string(nth 3 itemlst)) (string(nth 4 itemlst)) "clWhite" "clWhite")
	 (MAIN:pdImageRefresh   MAIN:pdScriptInstanceAddr "pdImageRefresh")
	 (if (> dtime 0)
	  (sleep dtime)
	 )
	 )
	 (begin
	 (MAIN:pdImageRectangle MAIN:pdScriptInstanceAddr "pdImageRectangle" (string(nth 1 itemlst)) (string(nth 2 itemlst)) (string(nth 3 itemlst)) (string(-(nth 4 itemlst)1)) "clWhite" "clWhite")
	 (MAIN:pdImageDrawLine  MAIN:pdScriptInstanceAddr "pdImageDrawLine"  (string polex)          (string(nth 2 itemlst)) (string polex)          (string(nth 4 itemlst))     "clNavy" "" "")
	 (MAIN:pdImageFillRect  MAIN:pdScriptInstanceAddr "pdImageFillRect"  (string(+ polex 1))     (string(nth 2 itemlst)) (string(- polex1 1))    (string(nth 4 itemlst))     "clLime")
	 (MAIN:pdImageDrawLine  MAIN:pdScriptInstanceAddr "pdImageDrawLine"  (string polex1)         (string(nth 2 itemlst)) (string polex1)         (string(nth 4 itemlst))      "clNavy" "" "")
	 (MAIN:pdImageRefresh   MAIN:pdScriptInstanceAddr "pdImageRefresh")
	 (if (> dtime 0)
	  (sleep dtime)
	 )
	 )
	)
	)
  )
)

(define (hanoi-prep )
  (MAIN:pdImageRectangle MAIN:pdScriptInstanceAddr "pdImageRectangle" "0" "30" "500" "300" "clWhite" "clWhite")
  (MAIN:pdImageTextOut MAIN:pdScriptInstanceAddr "pdImageTextOut" "Towers Of Hanoi" "160" "30" "Times" "18" "clWhite" "clNavy")
  (MAIN:pdImageRefresh   MAIN:pdScriptInstanceAddr "pdImageRefresh")
)

(define (make-disk disk pole height , x x1 y y1 width)
  (set 'x
   (case pole
    (pole1 115)
    (pole2 235)
    (pole3 355)))
  (set	'width	(+ 20 (* 10 disk))
	'x	(- x (/ width 2))
	'y	(- 250 (* 10 height))
	'x1	(+ x width)
	'y1	(+ y 10)
  )
  (set 'disklst (append disklst (list(list disk x y x1 y1))))
  (MAIN:pdImageRectangle MAIN:pdScriptInstanceAddr "pdImageRectangle" (string x) (string y) (string x1) (string y1) "clNavy" "clRed")
  (MAIN:pdImageRefresh   MAIN:pdScriptInstanceAddr "pdImageRefresh")
  (if (> dtime 0)
   (sleep dtime)
  )
)

(define (move n from to with)
  (if (> n 0)
   (begin
    (move (- n 1) from with to)
    (pull-disk n from)
    (move-disk-over n from to)
    (push-disk n to)
    (move (- n 1) with to from)
   )
  )
)

(define (move-disk-over n from to)
  (delete-disk n)
  (make-disk n to 18)
)

(set	'pole1	'()
	'pole2	'()
	'pole3	'(1 2 3 4 5)
)

(define (pull-disk n pole)
  (pop (eval pole))
  (delete-disk n)
  (make-disk n pole 18)
)

(define (push-disk n pole)
  (push n (eval pole))
  (delete-disk n)
  (make-disk n pole (length (eval pole)))
)

(define (run n ti)
  (set	'disklst '()
	'dtime ti
	'starttime (time-of-day))
  (hanoi-prep)
  (if (> n 10)
   (set 'n 10))
  (setup-poles n)
  (move n 'pole1 'pole3 'pole2)
  (set 'endtime (time-of-day))
)

(define (setup-poles n)
  (set 'pole1 (set 'pole2 (set 'pole3 '())))
  (MAIN:pdImageRectangle MAIN:pdScriptInstanceAddr "pdImageRectangle" "50"  "250" "440" "260" "clNavy" "clLime")
  (MAIN:pdImageRectangle MAIN:pdScriptInstanceAddr "pdImageRectangle" "110" "90"  "120" "250" "clNavy" "clLime")
  (MAIN:pdImageRectangle MAIN:pdScriptInstanceAddr "pdImageRectangle" "230" "90"  "240" "250" "clNavy" "clLime")
  (MAIN:pdImageRectangle MAIN:pdScriptInstanceAddr "pdImageRectangle" "350" "90"  "360" "250" "clNavy" "clLime")
  (MAIN:pdImageRefresh   MAIN:pdScriptInstanceAddr "pdImageRefresh")
  (while (> n 0)
   (push n pole1)
   (make-disk n 'pole1 (length pole1))
   (MAIN:pdImageRefresh   MAIN:pdScriptInstanceAddr "pdImageRefresh")
   (dec n)
  )
)

(context 'MAIN)
;EOF